(******************************************************************************
 * capnp-ocaml
 *
 * Copyright (c) 2013-2014, Paul Pelzl
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************)

(** Module InnerArray.  This is not intended for public use; you are looking for
    module Array. *)

type ro = Message.ro
type rw = Message.rw

type ('cap, 'a, 'arr) t = {
  mutable length : int;
  mutable storage : 'arr option;
  get_unsafe : 'arr -> int -> 'a;
  set_unsafe : 'arr -> int -> 'a -> unit;
  init : int -> 'arr;
}

val length : ('cap, 'a, 'arr) t -> int

val get : ('cap, 'a, 'arr) t -> int -> 'a

val set : (rw, 'a, 'arr) t -> int -> 'a -> unit

val init : (rw, 'a, 'arr) t -> int -> unit

val to_storage : ('cap, 'a, 'arr) t -> 'arr option

val invalid_get_unsafe : 'arr -> int -> 'a

val invalid_set_unsafe : 'arr -> int -> 'a -> unit

val invalid_init : int -> 'arr

